﻿-- Author      : Nogarder
-- Create Date : 2013/4/20 16:50:07
local COMBATLOG_OBJECT_REACTION_MASK=COMBATLOG_OBJECT_REACTION_MASK
local pairs=pairs
local UnitGUID=UnitGUID
local next=next
local string_split=string.split
--
local bit_band=bit.band
--

local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID

local NPA_CombatTextManager_AddText=NPA.CombatTextManager.AddText

local NPA_SpellInfo_GetSpellInfo=NPA.SpellInfo.GetSpellInfo
--
local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID
--
local NPA_FrameToGUID_GetFrameByGUID=NPA.FrameToGUID.GetFrameByGUID

local NPA_SpellInfo_GetSpellInfo=NPA.SpellInfo.GetSpellInfo
--
local GetType=function(guid,flag)
	--1=player 2=target 3=focus 4=mouseover ,5=pets --64=hostile 32=neutral, 16=friendly
	if(guid==UnitGUID("player"))then
		return 1
	elseif(guid==UnitGUID("target"))then
		return 2
	elseif(guid==UnitGUID("focus"))then
		return 3
	elseif(guid==UnitGUID("mouseover"))then
		return 4
	else
		local unitdata=NPA_DataCollector_GetUnitDataByGUID(UnitGUID("player"))
		if(unitdata and unitdata.Summon and unitdata.Summon[guid])then
			return 5
		else
			return bit_band(flag,COMBATLOG_OBJECT_REACTION_MASK) -- hostile=64, neutral=32, friendly=16
		end
	end
end
--
--return icon,text,school
local GetIconAndTextOnTarget={
	--swing don't have icon
	["SWING_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[12]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[15] or 0)+(arg[16] or 0)+(arg[17] or 0)
			if(absorb>0)then
				text="-"..arg[12].."(-"..absorb..")"
			else
				text="-"..arg[12]
			end
		end
		return nil,text,0
	end,
	["SWING__EXTRA_ATTACKS"]=function(arg,texttype) --same as damage
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[12]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[15] or 0)+(arg[16] or 0)+(arg[17] or 0)
			if(absorb>0)then
				text="-"..arg[12].."(-"..absorb..")"
			else
				text="-"..arg[12]
			end
		end
		return nil,text,0
	end,
	--
	["SWING_MISSED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[12]
		elseif(texttype==2)then --2=detail
			if(arg[14])then
				text="-"..arg[12].."(-"..arg[14]..")"
			else
				text="-"..arg[12]
			end
		end
		return nil,text,0
	end,
	--
	--range type-- range also don't have icon
	["RANGE_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return nil,text,0
	end,
	--
	["RANGE_EXTRA_ATTACKS"]=function(arg,texttype) --same as damage
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return nil,text,0
	end,
	["RANGE_MISSED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			if(arg[17])then
				text="-"..arg[15].."("..arg[17]..")"
			else
				text="-"..arg[15]
			end
		end
		return nil,text,0
	end,
	--spell damage type
	["SPELL_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[17]
	end,
	--
	["SPELL_PERIODIC_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[17]
	end,
	--
	["SPELL_MISSED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			if(arg[17])then
				text="-"..arg[15].."("..arg[17]..")"
			else
				text="-"..arg[15]
			end
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--["SPELL_DISPEL_FAILED"]=function(arg,texttype) --when to use these?
	--["SPELL_DAMAGE_SHIELD_DAMAGE"]=function(arg,texttype)
	--["SPELL_DAMAGE_SPLIT_DAMAGE"]=true,
	--["SPELL_DAMAGE_SHIELD_MISSED"]=true,
	--aura apply type
	["SPELL_AURA_APPLIED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="+"
		elseif(texttype==2)then --2=detail
			text="+("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_AURA_APPLIED_DOSE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="+"..arg[16]
		elseif(texttype==2)then --2=detail
			text="+"..arg[16].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--aura remove type
	["SPELL_AURA_REMOVED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"
		elseif(texttype==2)then --2=detail
			text="-("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--
	["SPELL_AURA_BROKEN"]=function(arg,texttype) --same as removed
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--
	["SPELL_AURA_BROKEN_SPELL"]=function(arg,texttype) --arg is slightly different
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--
	["SPELL_AURA_REMOVED_DOSE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[16]
		elseif(texttype==2)then --2=detail
			text="-"..arg[16].."("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_STOLEN"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[15]).Icon,text,arg[14]
	end,
	["SPELL_DISPEL"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[15]).Icon,text,arg[14]
	end,
	--energy type
	["SPELL_ENERGIZE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="+"..arg[15]
		elseif(texttype==2)then --2=detail
			text="+"..arg[15].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_DRAIN"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			text="-"..arg[15].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_LEECH"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			text="-"..arg[15].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--inturrpt type
	["SPELL_INTERRUPT"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"..arg[16]
		elseif(texttype==2)then --2=detail
			text="X"..arg[16].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[15]).Icon,text,arg[14]
	end,
	--summon type
	["SPELL_CREATE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="->"..arg[9]
		elseif(texttype==2)then --2=detail
			text="->"..arg[9].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_SUMMON"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="->"..arg[9]
		elseif(texttype==2)then --2=detail
			text="->"..arg[9].."("..arg[13]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_RESURRECT"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="=>"..arg[9]
		elseif(texttype==2)then --2=detail
			text="=>"..arg[9].."("..arg[13]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--special type
	--["UNIT_DIED"]=function(arg,texttype) --died ,placeholder
	--	return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	--end,
	["UNIT_DESTROYED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"..arg[9]
		elseif(texttype==2)then --2=detail
			text="X"..arg[9].."("..(arg[5] or "?")..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["ENVIRONMENTAL_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[13]
		elseif(texttype==2)then --2=detail
			text="-"..arg[13].."("..arg[12]..")"
		end
		return nil,text,0
	end,
	--heal type
	["SPELL_HEAL"]=function(arg,texttype)
		local text
		local absorb=(arg[16] or 0) +(arg[17] or 0)
		if(absorb>0)then
			if(texttype==1)then --1=no detail
				text="+"..(arg[15]-absorb)
			elseif(texttype==2)then --2=detail
				text="+"..(arg[15]-absorb).."("..absorb..")"
			end
		else
			text="+"..arg[15]
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_PERIODIC_HEAL"]=function(arg,texttype) --same as heal
		local text
		local absorb=(arg[16] or 0) +(arg[17] or 0)
		if(absorb>0)then
			if(texttype==1)then --1=no detail
				text="+"..(arg[15]-absorb)
			elseif(texttype==2)then --2=detail
				text="+"..(arg[15]-absorb).."("..absorb..")"
			end
		else
			text="+"..arg[15]
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	---
}
local GetIconAndTextOnSource={
	--cast event
	["SPELL_CAST_START"]=function(arg,texttype)
		local text=arg[13] or ""
		local spellinfo=NPA_SpellInfo_GetSpellInfo(arg[12])
		local casttime=spellinfo.CastTime
		if(texttype==2 and casttime and casttime>0)then
			if(texttype==1)then --1=no detail
				text=text.."~"
			elseif(texttype==2)then
				text=text.."~ ("..casttime..")"
			end
		else
			text=text.."~"
		end
		return spellinfo,text,arg[14]
	end,
	["SPELL_CAST_SUCCESS"]=function(arg)
		local text=(arg[13] or "").."||"
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
}
--
--
NPA.EventHandler.RegisterEvent(6,"CombatText_SettingUpdated","CombatText_Main",function()
	--if setting is empty, unregister event
	if(next(NPA_Setting.CombatText))then
		local AnimationList=NPA_Setting.CombatText.Animation
		--
		local settings=NPA_Setting.CombatText.Condition
		--
		NPA.EventHandler.RegisterEvent(5,"Any","CombatText_Main",function(event,arg)
			local targetframe=NPA_FrameToGUID_GetFrameByGUID(arg[8])
			local sourceframe=NPA_FrameToGUID_GetFrameByGUID(arg[4])
			--
			if((targetframe and GetIconAndTextOnTarget[event]) or
				(sourceframe and GetIconAndTextOnSource[event]))then

				local from=GetType(arg[4],arg[6])
				local to=GetType(arg[8],arg[10])
				--
				local crittype
				if((event=="SWING_DAMAGE" and arg[18]) or	arg[21])then --crit info of melee swing is arg[18],else is arg[21]
					crittype=1 
				else
					crittype=2
				end
				--
				for _,setting in pairs(settings)do
					if((setting.From==0 or setting.From==from) and 
						(setting.To==0 or setting.To==to) and 
						(setting.CritType==0 or setting.CritType==crittype) and
						setting.EventList[event] and
						((setting.SpellListType==0) or
						 (setting.SpellListType==1 and setting.SpellList[arg[12] or 0]) or
						 (setting.SpellListType==2 and not setting.SpellList[arg[12] or 0]))
						)then --event filter
							if(GetIconAndTextOnTarget[event])then
								local icon,text,school=GetIconAndTextOnTarget[event](arg,setting.TextType)
								NPA_CombatTextManager_AddText(targetframe,icon,text,school,setting,AnimationList[setting.AnimationName])
							elseif(GetIconAndTextOnSource[event])then
								local icon,text,school=GetIconAndTextOnSource[event](arg,setting.TextType)
								NPA_CombatTextManager_AddText(sourceframe,icon,text,school,setting,AnimationList[setting.AnimationName])
							end
					end
				end
			end
		end)
	else
		NPA.EventHandler.RegisterEvent(5,"Any","CombatText_Main",nil)
	end
end)
--

--EventList={
--	--melee type
--	["SWING_DAMAGE"]=true,
--	["SWING_MISSED"]=true,
--	["SWING_EXTRA_ATTACKS"]=true,
--range type
--	["RANGE_DAMAGE"]=true,
--	["RANGE_MISSED"]=true,
--	["RANGE_EXTRA_ATTACKS"]=true,
--	--spell damage type
--	["SPELL_DAMAGE"]=true,
-- ["SPELL_PERIODIC_DAMAGE"]=true,
--	["SPELL_MISSED"]=true,
--	["SPELL_DISPEL_FAILED"]=true, --dispel fail
--	--damage shield type
--	["SPELL_DAMAGE_SHIELD_DAMAGE"]=true,
--	["SPELL_DAMAGE_SPLIT_DAMAGE"]=true,
--	["SPELL_DAMAGE_SHIELD_MISSED"]=true,
--	--aura apply type
--	["SPELL_AURA_APPLIED"]=true,
--	["SPELL_AURA_APPLIED_DOSE"]=true,
--	--aura remove type
--	["SPELL_AURA_REMOVED"]=true,
--	["SPELL_AURA_REMOVED_DOSE"]=true,
--	["SPELL_AURA_BROKEN"]=true, --removed by melee --usually cc spell
--	["SPELL_AURA_BROKEN_SPELL"]=true, --removed by spell
--	["SPELL_STOLEN"]=true, --stolen for mage
--	["SPELL_DISPEL"]=true,
--	--energy type
--	["SPELL_ENERGIZE"]=true, --get energy by spell
--	["SPELL_DRAIN"]=true, --cause target to lose energy by spell
--	["SPELL_LEECH"]=true, --cause target to lose energy ,and get energy for self, by spell
--	--inturrpt type
--	["SPELL_INTERRUPT"]=true, --get interrupt by spell
--	--summon type
--	["SPELL_CREATE"]=true, --create something 
--	["SPELL_SUMMON"]=true, --summon, like pet, tottem,etc
--	["SPELL_RESURRECT"]=true, --resurrect someone
--	--special type
--	["UNIT_DIED"]=true, --unit just died
--	["UNIT_DESTROYED"]=true, --happens to old tottem when new tottem is summoned 
--	["ENVIRONMENTAL_DAMAGE"]=true, --environmental damage,
-- --heal type
--["SPELL_HEAL"]=true,
--["SPELL_PERIODIC_HEAL"]=true,
--cast type
--["SPELL_CAST_START"]=true,
--["SPELL_CAST_SUCCESS"]=true,
--}
